PackageKind (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.enumeration

## Enum PackageKind

- java.lang.Object
- - java.lang.Enum<PackageKind>
  - - tv.amwa.maj.enumeration.PackageKind

- All Implemented Interfaces:
    Serializable, Comparable<PackageKind>, MediaEnumerationValue

      public enum PackageKind
      extends Enum<PackageKind>
      implements MediaEnumerationValue

  Specifies the kind of a package. This is used when searching for a package.

  See Also:
    `Package`, `ContentStorage.countPackages(PackageKind)`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `AllPackages` Matches any package.
    `CompositionPackage` Package is a composition package.
    `FilePackage` Package is a source package described by a file descriptor.
    `FilmPackage` Package is a source package described by a film descriptor.
    `MaterialPackage` Package is a material package.
    `PhysicalPackage` Package is a source package described by a physical descriptor.
    `PrimaryPackage` TODO add a definition of primary package here
    `TapePackage` Package is a source package described by a tape descriptor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `symbol()` Provides a name for the enumeration value that can be used in XML serialisation.
    `long` | `value()` Returns the unique integer value associated with an enumeration value, either according to the AAF specification and/or the current AAF meta dictionary.
    `static PackageKind` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static PackageKind[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tv.amwa.maj.industry.MediaEnumerationValue

      `name`

- - ### Enum Constant Detail

    - #### CompositionPackage

          public static final PackageKind CompositionPackage

      Package is a composition package.

    - #### MaterialPackage

          public static final PackageKind MaterialPackage

      Package is a material package.

    - #### FilePackage

          public static final PackageKind FilePackage

      Package is a source package described by a file descriptor.

    - #### TapePackage

          public static final PackageKind TapePackage

      Package is a source package described by a tape descriptor.

    - #### FilmPackage

          public static final PackageKind FilmPackage

      Package is a source package described by a film descriptor.

    - #### PrimaryPackage

          public static final PackageKind PrimaryPackage

      TODO add a definition of primary package here

      Package is a material package and the primary package within its package.

      See Also:
        `Preface.getPrimaryPackage()`, `Preface.setPrimaryPackage(tv.amwa.maj.model.Package)`

    - #### AllPackages

          public static final PackageKind AllPackages

      Matches any package.

    - #### PhysicalPackage

          public static final PackageKind PhysicalPackage

      Package is a source package described by a physical descriptor.

  - ### Method Detail

    - #### values

          public static PackageKind[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (PackageKind c : PackageKind.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static PackageKind valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### value

          @Int64
          public long value()

      Description copied from interface: `MediaEnumerationValue`

      Returns the unique integer value associated with an enumeration value, either according to the AAF specification and/or the current AAF meta dictionary.

      Specified by:
        `value` in interface `MediaEnumerationValue`
      Returns:
        Unique integer value associated with an enumeration constant.
      See Also:
        `MediaEnumerationValue.value()`

    - #### symbol

          public String symbol()

      Description copied from interface: `MediaEnumerationValue`

      Provides a name for the enumeration value that can be used in XML serialisation. The name is unique within the namespace of the owning type.

      As an example, the `ChannelStatusModeType` value `ChannelStatusModeType.Fixed` value has the name "`Fixed`" and symbol "`ChannelStatusMode_Fixed`".

      Specified by:
        `symbol` in interface `MediaEnumerationValue`
      Returns:
        Symbol name for this enumeration value.

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.